#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <float.h>

#include "vote.h"

#ifdef FALSE
#undef FALSE
#endif
#define FALSE 0

#ifdef TRUE
#undef TRUE
#endif
#define TRUE (!(FALSE))

/* This array conatins the data of all Citizens. */
#define __MAIN_C__NCITIZENS 6
t_Citizen Citizen[__MAIN_C__NCITIZENS];

/* This function fills the array Citizen[] with data for testing! */
/* It returns FALSE on error!                                     */
static int CitizenFillTest(t_Citizen C[], int NCitizens)
{
   int B;

   /* Exit with FALSE on error! */
   if (!C) return(FALSE);
   if (NCitizens <= 0) return(FALSE);

   /* TESTING! */
   if (NCitizens != __MAIN_C__NCITIZENS) return(FALSE);



   B = CitizenInit(&(C[0]), "Albert Einstein");
   if (!B) return(FALSE);
   ((C[0]).Vote.Voting)[0] = 1.0;



   B = CitizenInit(&(C[1]), "Isaac Newton");
   if (!B) return(FALSE);
   ((C[1]).Vote.Voting)[0] = 0.5;
   ((C[1]).Vote.Voting)[1] = 0.5;



   B = CitizenInit(&(C[2]), "Robert Koch");
   if (!B) return(FALSE);
   ((C[2]).Vote.Voting)[1] = -1.0;
   ((C[2]).Vote.Voting)[2] = 0.5;



   B = CitizenInit(&(C[3]), "Hermann Gundermann");
   if (!B) return(FALSE);
   ((C[3]).Vote.Voting)[3] = 0.5;
   ((C[3]).Vote.Voting)[4] = 0.5;
   ((C[3]).Vote.Voting)[5] = 0.5;



   B = CitizenInit(&(C[4]), "Julius Caesar");
   if (!B) return(FALSE);
   ((C[4]).Vote.Voting)[0] = 77;
   ((C[4]).Vote.Voting)[1] = -23;



   B = CitizenInit(&(C[5]), "Mahatma Gandhi");
   if (!B) return(FALSE);



   return(TRUE);
}

int main(int argc, char **argv)
{
   int B;
   int i;
   int j;

   t_Vote Result;

   /* Check constants __MAIN_C__! */
   if (__MAIN_C__NCITIZENS <= 0)
   {
      fprintf(stderr, "Error in __MAIN_C__NCITIZENS!\n");
      return(-1);
   }
   /* Check constants __VOTE_H__! */
   if (__VOTE_H__NPARTIES <= 0)
   {
      fprintf(stderr, "Error in __VOTE_H__NPARTIES!\n");
      return(-2);
   }

   /* Create test data! */
   B = CitizenFillTest(Citizen, __MAIN_C__NCITIZENS);
   /* Exit with message on error! */
   if (!B)
   {
      fprintf(stderr, "Error in testing citizens!\n");
      return(-3);
   }

   /* Loop through the citizens and normalize the votings! */
   for (i=0; i<__MAIN_C__NCITIZENS; i++)
   {
      B = VoteNormalize100(&(Citizen[i].Vote));
      /* Exit with message on error! */
      if (!B)
      {
         fprintf(stderr, "Error in normalizing citizen[%d]!\n", i);
         return(-4);
      }
   }

   /* Loop through the votes of every citizen and compute the result! */
   /* All votes of Citizen[] must be treated by VoteNormalize100()! */
   B = CitizenVoteAccumulate(Citizen, __MAIN_C__NCITIZENS, &Result);
   /* Exit with message on error! */
   if (!B)
   {
      fprintf(stderr, "Error in clearing the result!\n");
      return(-5);
   }

   /* Kick out all parties with voting < 0.0! */
   B = VoteTrim_gt0(&Result);
   /* Exit with message on error! */
   if (!B)
   {
      fprintf(stderr, "Error in trimming result!\n");
      return(-6);
   }

   /* Print the sinlge votes (for debugging)! */
   printf("\nVoting details (debugging):\n");
   printf("========================================\n\n");
   for (i=0; i<__MAIN_C__NCITIZENS; i++)
   {
      printf("Name:   %32s\n", (Citizen[i]).Name);
      printf("----------------------------------------\n\n");
      for (j=0; j<__VOTE_H__NPARTIES; j++)
      {
         printf("%10s    %3.2f\n", Party[j], ((Citizen[i]).Vote.Voting)[j]);
  
      }
      printf("\n----------------------------------------\n\n");
   }
   printf("========================================\n\n\n\n\n");

   /* Print the result! */
   printf("Result:\n");
   printf("========================================\n\n");
   for (j=0; j<__VOTE_H__NPARTIES; j++)
   {
      printf("%10s    %3.2f\n", Party[j], (Result.Voting)[j]);
   }
   printf("\n========================================\n\n");

   return(0);
}
