#ifndef __VOTE_H__
#define __VOTE_H__

#define __VOTE_H__CHAR_BUFFER_SIZE 255
#define __VOTE_H__NPARTIES 7

/* This array contains the names of the involved political parties. */
extern char Party[__VOTE_H__NPARTIES][__VOTE_H__CHAR_BUFFER_SIZE + 1];

/* This struct contains the vote of a single citizen. */
typedef struct
{
   double Voting[__VOTE_H__NPARTIES];
} t_Vote;

/* This struct conatins the whole data of a single citizen. */
typedef struct
{
   char Name[__VOTE_H__CHAR_BUFFER_SIZE + 1];
   t_Vote Vote;
} t_Citizen;

/* Set *VP to initial values. */
extern int VoteZERO(t_Vote *VP);
extern int CitizenInit(t_Citizen *CP, char *Name);

/* Check *VP for ZERO. */
/* VoteIsZERO_Check() must be called before calling VoteIsZERO(). */
extern int VoteIsZERO_Check(t_Vote *VP);
extern int VoteIsZERO(t_Vote *VP);

/* Compute centroids. */
/* VoteSumAbs_Check() must be called before calling VoteSumAbs(). */
extern int VoteSumAbs_Check(t_Vote *VP);
extern double VoteSumAbs(t_Vote *VP);
extern int VoteNormalize100(t_Vote *VP);
extern int VoteTrim_gt0(t_Vote *VP);

/* The core! */
/* All (C[]).Vote must be normalized by calling VoteNormalize100() before calling this function. */
extern int CitizenVoteAccumulate(t_Citizen C[], int NCitizens, t_Vote *ResultP);

#endif
